## newsbeuter 2.8

=== Makefile ===
# important directories
prefix?=/usr/local
mandir?=$(prefix)/share/man
datadir?=$(prefix)/share
localedir?=$(datadir)/locale
docdir?=$(datadir)/doc/$(PACKAGE)

# compiler
CXX=c++

# compiler and linker flags
DEFINES=-DLOCALEDIR=\"$(localedir)\"
WARNFLAGS=-Wall -Wextra
CXXFLAGS+=-ggdb -Iinclude -Istfl -Ifilter -I. -Irss $(WARNFLAGS) $(DEFINES)
LDFLAGS+=-L.

PACKAGE=newsbeuter

ifneq (distclean, $(MAKECMDGOALS))
include config.mk
endif

ifeq ($(PROFILE),1)
CXXFLAGS+=-fprofile-arcs -ftest-coverage
endif

LIB_SOURCES:=$(shell cat mk/libbeuter.deps)
LIB_OBJS:=$(patsubst %.cpp,%.o,$(LIB_SOURCES))
LIB_OUTPUT=libbeuter.a

FILTERLIB_SOURCES=filter/Scanner.cpp filter/Parser.cpp filter/FilterParser.cpp
FILTERLIB_OBJS:=$(patsubst %.cpp,%.o,$(FILTERLIB_SOURCES))
FILTERLIB_OUTPUT=libfilter.a

NEWSBEUTER=newsbeuter
NEWSBEUTER_SOURCES:=$(shell cat mk/newsbeuter.deps)
NEWSBEUTER_OBJS:=$(patsubst %.cpp,%.o,$(NEWSBEUTER_SOURCES))
NEWSBEUTER_LIBS=-lbeuter -lfilter -lpthread -lrsspp

RSSPPLIB_SOURCES=$(wildcard rss/*.cpp)
RSSPPLIB_OBJS=$(patsubst rss/%.cpp,rss/%.o,$(RSSPPLIB_SOURCES))
RSSPPLIB_OUTPUT=librsspp.a


PODBEUTER=podbeuter
PODBEUTER_SOURCES:=$(shell cat mk/podbeuter.deps)
PODBEUTER_OBJS:=$(patsubst %.cpp,%.o,$(PODBEUTER_SOURCES))
PODBEUTER_LIBS=-lbeuter -lpthread

ifeq (, $(filter Linux GNU GNU/%, $(shell uname -s)))
NEWSBEUTER_LIBS+=-liconv -lintl
PODBEUTER_LIBS+=-liconv -lintl
endif

# additional commands
MKDIR=mkdir -p
INSTALL=install
A2X=a2x
MSGFMT=msgfmt
RANLIB=ranlib
AR=ar

STFLHDRS:=$(patsubst %.stfl,%.h,$(wildcard stfl/*.stfl))
POFILES:=$(wildcard po/*.po)
MOFILES:=$(patsubst %.po,%.mo,$(POFILES))
POTFILE=po/newsbeuter.pot

TEXTCONV=./txt2h.pl
RM=rm -f

all: $(NEWSBEUTER) $(PODBEUTER)

NB_DEPS=$(MOFILES) $(LIB_OUTPUT) $(FILTERLIB_OUTPUT) $(NEWSBEUTER_OBJS) $(RSSPPLIB_OUTPUT)

$(NEWSBEUTER): $(NB_DEPS)
	$(CXX) $(CXXFLAGS) -o $(NEWSBEUTER) $(NEWSBEUTER_OBJS) $(NEWSBEUTER_LIBS) $(LDFLAGS)

$(PODBEUTER): $(MOFILES) $(LIB_OUTPUT) $(PODBEUTER_OBJS)
	$(CXX) $(CXXFLAGS) -o $(PODBEUTER) $(PODBEUTER_OBJS) $(PODBEUTER_LIBS) $(LDFLAGS)

$(LIB_OUTPUT): $(LIB_OBJS)
	$(RM) $@
	$(AR) qc $@ $^
	$(RANLIB) $@

$(RSSPPLIB_OUTPUT): $(RSSPPLIB_OBJS)
	$(RM) $@
	$(AR) qc $@ $^
	$(RANLIB) $@

$(FILTERLIB_OUTPUT): $(FILTERLIB_OBJS)
	$(RM) $@
	$(AR) qc $@ $^
	$(RANLIB) $@

regenerate-parser:
	$(RM) filter/Scanner.cpp filter/Parser.cpp filter/Scanner.h filter/Parser.h
	cococpp -frames filter filter/filter.atg

%.o: %.cpp
	$(CXX) $(CXXFLAGS) -o $@ -c $<

%.h: %.stfl
	$(TEXTCONV) $< .stfl > $@

clean-newsbeuter:
	$(RM) $(NEWSBEUTER) $(NEWSBEUTER_OBJS)

clean-podbeuter:
	$(RM) $(PODBEUTER) $(PODBEUTER_OBJS)

clean-libbeuter:
	$(RM) $(LIB_OUTPUT) $(LIB_OBJS)

clean-librsspp:
	$(RM) $(RSSPPLIB_OUTPUT) $(RSSPPLIB_OBJS)

clean-libfilter:
	$(RM) $(FILTERLIB_OUTPUT) $(FILTERLIB_OBJS)

#clean-doc:
#	$(RM) -r doc/xhtml 
#	$(RM) doc/*.xml doc/*.1 doc/newsbeuter-cfgcmds.txt doc/podbeuter-cfgcmds.txt doc/newsbeuter-keycmds.txt

clean: clean-newsbeuter clean-podbeuter clean-libbeuter clean-libfilter clean-librsspp
	$(RM) $(STFLHDRS) xlicense.h

distclean: clean clean-mo test-clean
	$(RM) core *.core core.* config.mk

doc:
	$(MKDIR) doc/xhtml
	$(A2X) -f xhtml -D doc/xhtml doc/newsbeuter.txt
	doc/generate.pl doc/configcommands.dsv > doc/newsbeuter-cfgcmds.txt
	doc/generate2.pl doc/keycmds.dsv > doc/newsbeuter-keycmds.txt
	$(A2X) -f manpage -D doc doc/manpage-newsbeuter.txt
	doc/generate.pl doc/podbeuter-cmds.dsv > doc/podbeuter-cfgcmds.txt
	$(A2X) -f manpage -D doc doc/manpage-podbeuter.txt

install: install-mo
	$(MKDIR) $(DESTDIR)$(prefix)/bin
	$(INSTALL) $(NEWSBEUTER) $(DESTDIR)$(prefix)/bin
	$(INSTALL) $(PODBEUTER) $(DESTDIR)$(prefix)/bin
	$(MKDIR) $(DESTDIR)$(mandir)/man1
	$(INSTALL) doc/$(NEWSBEUTER).1 $(DESTDIR)$(mandir)/man1 || true
	$(INSTALL) doc/$(PODBEUTER).1 $(DESTDIR)$(mandir)/man1 || true
	$(MKDIR) $(DESTDIR)$(docdir)
	$(INSTALL) -m 644 doc/xhtml/* $(DESTDIR)$(docdir) || true
	$(MKDIR) $(DESTDIR)$(docdir)/examples
	$(INSTALL) -m 644 doc/example-config $(DESTDIR)$(docdir)/examples/config || true

uninstall:
	$(RM) $(DESTDIR)$(prefix)/bin/$(NEWSBEUTER)
	$(RM) $(DESTDIR)$(prefix)/bin/$(PODBEUTER)
	$(RM) $(DESTDIR)$(mandir)/man1/$(NEWSBEUTER).1
	$(RM) $(DESTDIR)$(mandir)/man1/$(PODBEUTER).1
	$(RM) -r $(DESTDIR)$(docdir)

.PHONY: doc clean distclean all test test-rss extract install uninstall regenerate-parser clean-newsbeuter \
	clean-podbeuter clean-libbeuter clean-librsspp clean-libfilter install-mo msgmerge clean-mo \
	test-clean config

# the following targets are i18n/l10n-related:

extract:
	$(RM) $(POTFILE)
	xgettext -c/ -k_ -o $(POTFILE) *.cpp src/*.cpp rss/*.cpp

msgmerge:
	for f in $(POFILES) ; do msgmerge -U $$f $(POTFILE) ; done

%.mo: %.po
	$(MSGFMT) --statistics -o $@ $<

clean-mo:
	$(RM) $(MOFILES) po/*~

install-mo:
	$(MKDIR) $(DESTDIR)$(datadir)
	@for mof in $(MOFILES) ; do \
		mofile=`basename $$mof` ; \
		lang=`echo $$mofile | sed 's/\.mo$$//'`; \
		dir=$(DESTDIR)$(localedir)/$$lang/LC_MESSAGES; \
		$(MKDIR) $$dir ; \
		$(INSTALL) -m 644 $$mof $$dir/$(PACKAGE).mo ; \
		echo "Installing $$mofile as $$dir/$(PACKAGE).mo" ; \
	done

test: $(LIB_OUTPUT) $(NEWSBEUTER_OBJS) $(FILTERLIB_OUTPUT) $(RSSPPLIB_OUTPUT) test/test.o
	$(CXX) $(CXXFLAGS) -o test/test src/history.o src/rss.o src/rss_parser.o src/htmlrenderer.o src/cache.o src/tagsouppullparser.o src/urlreader.o src/regexmanager.o test/test.o src/ttrss_api.o src/newsblur_api.o src/markreadthread.o $(NEWSBEUTER_LIBS) $(LDFLAGS)

test-rss: $(RSSPPLIB_OUTPUT) test/test-rss.o
	$(CXX) $(CXXFLAGS) -o test/test-rss test/test-rss.o src/utils.o $(NEWSBEUTER_LIBS) $(LDFLAGS)

test/test.o: test/test.cpp
	$(CXX) $(CXXFLAGS) -o $@ -c $<

test-clean:
	$(RM) test/test test/test.o test/test-rss test/test-rss.o

profclean:
	find . -name '*.gc*' -type f | xargs $(RM)
	$(RM) app*.info

config: config.mk

config.mk:
	@./config.sh

xlicense.h: LICENSE
	$(TEXTCONV) $< > $@

include mk/mk.deps

=== debian/changelog ===
newsbeuter (2.8-2+deb8u2) jessie-security; urgency=high

  * Non-maintainer upload by the Security Team.
  * Work around shell code in podcast names (CVE-2017-14500)
    Remote code execution in podbeuter. (Closes: #876004)

 -- Salvatore Bonaccorso <carnil@debian.org>  Sun, 17 Sep 2017 16:55:08 +0200

newsbeuter (2.8-2+deb8u1) jessie-security; urgency=high

  * Fix RCE on bookmark. (CVE-2017-12904)

 -- Nikos Tsipinakis <nikos@tsipinakis.com>  Fri, 18 Aug 2017 07:01:24 +0300

newsbeuter (2.8-2) unstable; urgency=low

  * Add missing copyright statements for filter/Parser.frame,
    filter/Scanner.frame, and test/lemon.h (Closes: #760269).
  * Add version to GPL path in copyright file.

 -- Nico Golde <nion@debian.org>  Tue, 02 Sep 2014 12:15:52 +0200

newsbeuter (2.8-1) unstable; urgency=low

  * New upstream release.
   + Initialize pubDate_to  to fix crash on localtime() (Closes: #733307).
  * Add -dbg package. Thanks Erik Werner! (Closes: #733347).
  * Update build dependencies to libjson-c-dev as json-c has dropped
    has dropped a compatibility layer from libjson0 to libjson-c2
    (Closes: #745008).
  * Drop json type patches, no longer required.
  * Bump standards version.

 -- Nico Golde <nion@debian.org>  Fri, 18 Apr 2014 08:37:43 +0200

=== debian/control ===
Source: newsbeuter
Section: net
Priority: optional
Maintainer: Nico Golde <nion@debian.org>
Build-Depends: libncursesw5-dev, debhelper (>= 9), libxml2-dev, libstfl-dev (>= 0.19), libsqlite3-dev, perl, pkg-config, libcurl4-gnutls-dev, libjson-c-dev, dpkg-dev (>= 1.16.1~)
Standards-Version: 3.9.5
Homepage: http://www.newsbeuter.org

Package: newsbeuter
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: text mode rss feed reader with podcast support
 newsbeuter is an innovative RSS feed reader for the text console.
 It supports OPML import/exports, HTML rendering, podcast (podbeuter),
 offline reading, searching and storing articles to your filesystem,
 and many more features.
 .
 Its user interface is coherent, easy to use, and might look
 common to users of mutt and slrn.

Package: newsbeuter-dbg
Architecture: any
Section: debug
Priority: extra
Pre-Depends: dpkg (>= 1.15.6~)
Depends: newsbeuter (= ${binary:Version}), ${misc:Depends}
Description: debugging symbols for newsbeuter
 This package contains the debugging symbols for the text-mode feed reader
 newsbeuter.

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE=1

# quilt support
#include /usr/share/quilt/quilt.make

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
        CFLAGS += -O0
else
        CFLAGS += -O2
endif

build: build-arch build-indep
build-arch: build-stamp
build-indep: build-stamp

build-stamp:
	dh_testdir
	$(MAKE) prefix=/usr all
	touch $@

clean:
	dh_testdir
	dh_testroot
	rm -f build-stamp
	dh_clean

	$(MAKE) distclean

install: build
	dh_testdir
	dh_testroot
	dh_prep
	dh_installdirs

	$(MAKE) prefix=$(CURDIR)/debian/newsbeuter/usr install
	install -m644 debian/config $(CURDIR)/debian/newsbeuter/etc/newsbeuter

binary-indep: build install
binary-arch: build install
	dh_testdir
	dh_testroot
	dh_installchangelogs CHANGES
	dh_installdocs
	xargs -r -i install "{}" $(CURDIR)/debian/newsbeuter/usr/share/doc/newsbeuter/contrib < debian/contrib.files
	dh_link
	dh_strip --dbg-package=newsbeuter-dbg
	dh_compress
	dh_fixperms
	dh_installdeb
	dh_shlibdeps
	dh_gencontrol
	dh_md5sums
	dh_builddeb

binary: binary-indep binary-arch
.PHONY: build clean binary-indep binary-arch binary install

## newsbeuter 2.9

=== Makefile ===
--- 
+++ 
@@ -6,12 +6,12 @@
 docdir?=$(datadir)/doc/$(PACKAGE)
 
 # compiler
-CXX=c++
+CXX?=c++
 
 # compiler and linker flags
 DEFINES=-DLOCALEDIR=\"$(localedir)\"
-WARNFLAGS=-Wall -Wextra
-CXXFLAGS+=-ggdb -Iinclude -Istfl -Ifilter -I. -Irss $(WARNFLAGS) $(DEFINES)
+WARNFLAGS=-Wall -Wextra -Wunreachable-code
+CXXFLAGS+=-std=c++11 -ggdb -Iinclude -Istfl -Ifilter -I. -Irss $(WARNFLAGS) $(DEFINES)
 LDFLAGS+=-L.
 
 PACKAGE=newsbeuter
@@ -136,6 +136,9 @@
 	$(A2X) -f manpage -D doc doc/manpage-newsbeuter.txt
 	doc/generate.pl doc/podbeuter-cmds.dsv > doc/podbeuter-cfgcmds.txt
 	$(A2X) -f manpage -D doc doc/manpage-podbeuter.txt
+
+fmt:
+	astyle --suffix=none --style=java --indent=tab --indent-classes *.cpp include/*.h src/*.cpp rss/*.{cpp,h} test/*.cpp
 
 install: install-mo
 	$(MKDIR) $(DESTDIR)$(prefix)/bin

=== debian/changelog ===
newsbeuter (2.9-8) unstable; urgency=medium

  * Added NEWS entry about newsboat fork
  * d/control: Recommend newsboat

 -- Nikos Tsipinakis <nikos@tsipinakis.com>  Tue, 27 Mar 2018 18:03:01 +0300

newsbeuter (2.9-7) unstable; urgency=high

  * Fix CVE-2017-14500 (Closes: #876004)
  * Update copyright year
  * Bump standards to 4.0.1
   + Updated copyright-format URL to https as per policy 4.0.0
  * Dropped version contraint in libstfl-dev dependency (No older versions in
    the archive

 -- Nikos Tsipinakis <nikos@tsipinakis.com>  Sun, 17 Sep 2017 22:28:04 +0300

newsbeuter (2.9-6) unstable; urgency=high

  * Fix RCE vulnerability on bookmark (CVE-2017-12904)
  * Use pkg-config to test for ncursesw. Closes: #850734
  * Link binaries deterministically in order to build reproducibly
  * debian/patches
   + Update DEP-3 headers

 -- Nikos Tsipinakis <nikos@tsipinakis.com>  Thu, 12 Jan 2017 19:05:54 +0200

newsbeuter (2.9-5) unstable; urgency=medium

  * Refreshed patches.
  * Remove unnecessary code in d/rules.
  * Add doc-base registration for the docs.
  * Use dh_installdocs to install the contrib directory.
  Added patches:
  * 21-parse-h5-h6-html-headers.patch: Fix h5 and h6 html elements not being
    parsed correctly.

 -- Nikos Tsipinakis <nikos@tsipinakis.com>  Tue, 27 Dec 2016 09:15:53 +0200

newsbeuter (2.9-4) unstable; urgency=medium

  * debian/patches:
   + 01-typos.patch: Fix typos.
   + 02-new-issue-tracker.patch: Update docs to reference the new issue tracker.
   + Rename podbeuter-segfault-fix -> 03-podbeuter-segfault-fix.patch
   + 04-cache-deletion-with-one-feed.patch: Fix a bug deleting the cache if
   there's only one feed in the urls file.
   + Rename fix-memory-leak -> 05-fix-memory-leak.patch
   + Rename fix-highlight -> 06-fix-highlight.patch
   + 07-json-object-get.patch: Replace deprecated json_object_get calls.
   + 08-feeds-marked-unread.patch: Fix a bug that occasionally marks entire
   feeds unread.
   + 09-config-parser-off-by-one.patch: Fix an off-by-one error in the
   configparser sometimes breaking the highlight option.
   + 10-a2x-warnings.patch: Fix a2x warnings when compiling the documentation.
   + 11-query-feed-tokenization.patch: Fix ranges in query feeds.
   + 12-highlight-article-priority.patch: Fix priority of highlight-article so
   it works with unread items.
   + 13-dont-include-compilation-time.patch: Don't use __DATE__ and __TIME__ to
   allow for reproducible builds.
   + 14-handle-url-files-lacking-eol.patch: Fix newsbeuter not properly handling
   urls file without an EOL character at the end.
   + 15-dont-skip-ignored.patch: Don't skip items while applying ignore rules.
   + 16-fix-invalid-pointers.patch: Fix a use after free in the rss parser.
   + 17-dont-ignore-self-closing-tags.patch: Don't ignore self closing tags in
   the HTML parser.
   + 18-ssl-verify.patch: Newsbeuter's behaviour was to skip all SSL certificate
   verification, this patch enables verification by default and adds an
   ssl-verify option to disable it if required.
   + 19-clean-doc.patch: Uncomment clean-doc target and set it as a prerequisite
   to the clean target.
   + 20-prevent-http-header-reset.patch: Fix a bug that reset the HTTP headers
   breaking remote APIs.
   + doc/101-macro-example.patch: Fix incorrect example macro in the docs.
   + doc/102-color-config-example.patch: Show the actual commands in the default
   colour config example.
   + l10n/201-german-l10n-revision.patch: Revise the German translation.
   + Rename translation-fix.patch -> l10n/202-translation-fix.patch
  * debian/rules
   + Rebuild the docs before compiling.
   + Copy the entire contrib/ directory to usr/share/doc/newsbeuter, not just a
   few files.
  * debian/control
    + Add Build-Deps required to build the docs: asciidoc, libxml2-utils,
    xsltproc, docbook-xml, docbook-xsl
  * Bump standards to 3.9.8

 -- Nikos Tsipinakis <nikos@tsipinakis.com>  Fri, 28 Oct 2016 11:30:36 +0300

newsbeuter (2.9-3) unstable; urgency=medium

  * Fix memory leak. (Closes: #776728)
  * Migrate to debhelper.
  * Update homepage and watch file to use SSL.
  * Added current maintainer to the copyright file.

 -- Nikos Tsipinakis <nikos@tsipinakis.com>  Sat, 02 Apr 2016 13:57:34 +0300

newsbeuter (2.9-2) unstable; urgency=low

  * Completely removed newsbeuter-dbg from debian/control.

 -- Nikos Tsipinakis <nikos@tsipinakis.com>  Sun, 13 Mar 2016 12:15:31 +0200

newsbeuter (2.9-1) unstable; urgency=low

  * New upstream release. (Closes: #776728)
  * Fix segfault when downloading podcasts.
  * Fix highlight article option.
  * Patch erroneous Portuguese, Ukrainian and Chinese translations.
  * Debug symbols for newsbeuter are now provided by newsbeuter-dbgsym,
      newsbeuter-dbg is now obsolete and can be safely removed.
  * Fixed hardening options.
  * Updated copyright to format 1.0
  * Bumped standards to 3.9.7
  * Updated watch file.
  * Removed upstream README from docs.
  * New maintainer. (Closes: #800752)

 -- Nikos Tsipinakis <nikos@tsipinakis.com>  Fri, 11 Mar 2016 22:21:54 +0200

=== debian/control ===
Source: newsbeuter
Section: net
Priority: optional
Maintainer: Nikos Tsipinakis <nikos@tsipinakis.com>
Build-Depends: libncursesw5-dev, debhelper (>= 9), libxml2-dev, libstfl-dev, libsqlite3-dev, perl, pkg-config, libcurl4-gnutls-dev, libjson-c-dev, dpkg-dev (>= 1.16.1~), asciidoc, libxml2-utils, xsltproc, docbook-xml, docbook-xsl
Standards-Version: 4.0.1
Homepage: https://www.newsbeuter.org

Package: newsbeuter
Architecture: any
Recommends: newsboat
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: text mode rss feed reader with podcast support
 newsbeuter is an innovative RSS feed reader for the text console.
 It supports OPML import/exports, HTML rendering, podcast (podbeuter),
 offline reading, searching and storing articles to your filesystem,
 and many more features.
 .
 Its user interface is coherent, easy to use, and might look
 common to users of mutt and slrn.

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE=1

# quilt support
#include /usr/share/quilt/quilt.make

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

CFLAGS += $(CPPFLAGS)
CXXFLAGS += $(CPPFLAGS)

%:
	dh $@

override_dh_auto_build:
	dh_auto_build -- prefix=/usr all
	make doc

override_dh_auto_install:
	dh_auto_install -- prefix=/usr
	install -m644 debian/config.default $(CURDIR)/debian/newsbeuter/etc/newsbeuter/config
